import 'package:iform/style/iform_styling.dart';
import 'package:nui_core/data/nui_data_util.dart';
import 'package:nui_core/data/nui_ent.dart';
import 'iform_common_json.dart';

typedef IFOnButtonsRowTapped = Function(String inpId, int index);

class IFButtonItemJson extends NUIEnt<IFButtonItemJson> with IFCommonJson{
  IFButtonItemJson.empty();
  int eleType;
  IFButtonStyle enabledStyle;
  IFButtonStyle disabledStyle;

  @override
  NUIEntMapper<IFButtonItemJson> mapper() => IFButtonItemJsonEnt();
}
class IFButtonItemJsonEnt extends NUIEntMapper<IFButtonItemJson>{
  @override
  String entityName() => "IFButtonItemJson";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFButtonItemJson>();
    fields.add(NUIEntField<IFButtonItemJson>(name: "eleType", type: NUIEntType.INTEGER, setter: (data, value) => data.eleType = value, getter: (data) => data.eleType));
    fields.add(NUIEntField<IFButtonItemJson>(name: "enabledStyle", type: NUIEntType.OBJECT, setter: (data, value) => data.enabledStyle = asObject(IFButtonStyleEnt(), value), getter: (data) => data.enabledStyle));
    fields.add(NUIEntField<IFButtonItemJson>(name: "disabledStyle", type: NUIEntType.OBJECT, setter: (data, value) => data.disabledStyle = asObject(IFButtonStyleEnt(), value), getter: (data) => data.disabledStyle));
    return fields;
  }

  @override
  IFButtonItemJson newInstance() => IFButtonItemJson.empty();
}


class IFButtonRowJson extends NUIEnt<IFButtonRowJson> with IFCommonJson{
  IFButtonRowJson.empty();
  double spaceBetIntHoriComponent;
  @override
  NUIEntMapper<IFButtonRowJson> mapper() => IFButtonRowJsonEnt();

  List<IFButtonItemJson> getChildElements(){
    if(isNullOrEmpty(childElements)) return List();
    return childElements.map((e) => asObject<IFButtonItemJson>(IFButtonItemJsonEnt(), e)).toList();
  }
}

class IFButtonRowJsonEnt extends NUIEntMapper<IFButtonRowJson>{
  @override
  String entityName() => "NUIFButtonRow";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFButtonRowJson>();
    fields.add(NUIEntField<IFButtonRowJson>(name: "spaceBetIntHoriComponent", type: NUIEntType.DOUBLE, setter: (data, value) => data.spaceBetIntHoriComponent = value, getter: (data) => data.spaceBetIntHoriComponent));
    return fields;
  }

  @override
  IFButtonRowJson newInstance() => IFButtonRowJson.empty();
}