import 'package:iform/component/iform_common_json.dart';
import 'package:iform/component/iform_singleline_text_json.dart';
import 'package:nui_core/data/nui_data_util.dart';
import 'package:nui_core/data/nui_ent.dart';

typedef IFCheckGroupValueChangeListener = Function(String value);

class IFCheckGroupJson extends NUIEnt<IFCheckGroupJson> with IFCommonJson{
  IFCheckGroupJson.empty();
  int chkGroupTxtBoxPreferredWidth;
  bool singleSelection;
  bool asRadioButton;
  int numRadiosPerContainer;
  int spaceBetIntHoriComponent;
  IFCheckGroupValueChangeListener onValueChange;
  Function onFocus;
  String otherTxtPlaceHolder;

  @override
  NUIEntMapper<IFCheckGroupJson> mapper() => IFCheckGroupJsonEnt();

  List<IFChildElement> getChildElements(){
    if(isNullOrEmpty(childElements)) return List();
    return childElements.map((e) => asObject<IFChildElement>(IFChildElementEnt(), e)).toList();
  }

  List<IFSingleLineTextJson> getChildElementsAsText(){
    if(isNullOrEmpty(childElements)) return List();
    return childElements.map((e) => asObject<IFSingleLineTextJson>(IFSingleLineTextJsonEnt(), e)).toList();
  }
}

class IFCheckGroupJsonEnt extends NUIEntMapper<IFCheckGroupJson>{
  @override
  String entityName() => "IFCheckGroupJson";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFCheckGroupJson>();
    fields.add(NUIEntField<IFCheckGroupJson>(name: "chkGroupTxtBoxPreferredWidth", type: NUIEntType.INTEGER, setter: (data, value) => data.chkGroupTxtBoxPreferredWidth = value, getter: (data) => data.chkGroupTxtBoxPreferredWidth));
    fields.add(NUIEntField<IFCheckGroupJson>(name: "singleSelection", type: NUIEntType.BOOLEAN, setter: (data, value) => data.singleSelection = value, getter: (data) => data.singleSelection));
    fields.add(NUIEntField<IFCheckGroupJson>(name: "asRadioButton", type: NUIEntType.BOOLEAN, setter: (data, value) => data.asRadioButton = value, getter: (data) => data.asRadioButton));
    fields.add(NUIEntField<IFCheckGroupJson>(name: "numRadiosPerContainer", type: NUIEntType.INTEGER, setter: (data, value) => data.numRadiosPerContainer = value, getter: (data) => data.numRadiosPerContainer));
    fields.add(NUIEntField<IFCheckGroupJson>(name: "spaceBetIntHoriComponent", type: NUIEntType.INTEGER, setter: (data, value) => data.spaceBetIntHoriComponent = value, getter: (data) => data.spaceBetIntHoriComponent));
    fields.add(NUIEntField<IFCheckGroupJson>(name: "otherTxtPlaceHolder", type: NUIEntType.STRING, setter: (data, value) => data.otherTxtPlaceHolder = value, getter: (data) => data.otherTxtPlaceHolder));
    return fields;
  }

  @override
  IFCheckGroupJson newInstance() =>IFCheckGroupJson.empty();
}
