import 'package:flutter/cupertino.dart';
import 'package:flutter/src/painting/text_style.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_core/nui_core.dart';
import 'package:nui_form/component/nuif_text.dart';
import 'package:nui_form/model/nuif_models.dart';

abstract class IFCommonJson{
  static List<NUIEntField> dbFields<T extends IFCommonJson>() {
    return [
      NUIEntField<T>(name: "inpId", type: NUIEntType.STRING, setter: (data, value) => data.inpId = value, getter: (data) => data.inpId),
      NUIEntField<T>(name: "caption", type: NUIEntType.STRING, setter: (data, value) => data.caption = value, getter: (data) => data.caption),
      NUIEntField<T>(name: "compulsory", type: NUIEntType.BOOLEAN, setter: (data, value) => data.compulsory = value, getter: (data) => data.compulsory),
      NUIEntField<T>(name: "show", type: NUIEntType.BOOLEAN, setter: (data, value) => data.show = value, getter: (data) => data.show),
      NUIEntField<T>(name: "layout", type: NUIEntType.INTEGER, setter: (data, value) => data.layout = value, getter: (data) => data.layout),
      NUIEntField<T>(name: "intLayout", type: NUIEntType.INTEGER, setter: (data, value) => data.intLayout = value, getter: (data) => data.intLayout),
      NUIEntField<T>(name: "preferredWidth", type: NUIEntType.INTEGER, setter: (data, value) => data.preferredWidth = value, getter: (data) => data.preferredWidth),
      NUIEntField<T>(name: "preferredCaptionWidth", type: NUIEntType.INTEGER, setter: (data, value) => data.preferredCaptionWidth = value, getter: (data) => data.preferredCaptionWidth),
      NUIEntField<T>(name: "type", type: NUIEntType.STRING, setter: (data, value) => data.type = value, getter: (data) => data.type),
      NUIEntField<T>(name: "topSpacing", type: NUIEntType.INTEGER, setter: (data, value) => data.topSpacing = value, getter: (data) => data.topSpacing),
      NUIEntField<T>(name: "bottomSpacing", type: NUIEntType.INTEGER, setter: (data, value) => data.bottomSpacing = value, getter: (data) => data.bottomSpacing),
      NUIEntField<T>(name: "leftSpacing", type: NUIEntType.INTEGER, setter: (data, value) => data.leftSpacing = value, getter: (data) => data.leftSpacing),
      NUIEntField<T>(name: "rightSpacing", type: NUIEntType.INTEGER, setter: (data, value) => data.rightSpacing = value, getter: (data) => data.rightSpacing),
      NUIEntField<T>(name: "readOnly", type: NUIEntType.BOOLEAN, setter: (data, value) => data.readOnly = value, getter: (data) => data.readOnly),
      NUIEntField<T>(name: "minLines", type: NUIEntType.INTEGER, setter: (data, value) => data.minLines = value, getter: (data) => data.minLines),
      NUIEntField<T>(name: "maxLines", type: NUIEntType.INTEGER, setter: (data, value) => data.maxLines = value, getter: (data) => data.maxLines),
      NUIEntField<T>(name: "otherTxtPlaceHolder", type: NUIEntType.STRING, setter: (data, value) => data.otherTxtPlaceHolder = value, getter: (data) => data.otherTxtPlaceHolder),
      NUIEntField<T>(name: "childElements", type: NUIEntType.LIST_MAP, setter: (data, value) => data.childElements = asList<Map<String, dynamic>>(value), getter: (data) => data.childElements),
    ];
  }
  String inpId;
  String caption;
  bool compulsory;
  bool show;
  int layout;
  int intLayout;
  int preferredWidth;
  int preferredCaptionWidth;
  String type;
  int topSpacing;
  int leftSpacing;
  int rightSpacing;
  int bottomSpacing;
  bool readOnly;
  int minLines;
  int maxLines;
  String otherTxtPlaceHolder;
  List<Map<String, dynamic>> childElements;

  String getId(){
    if(inpId.isNullOrEmpty()) inpId = randomUUID();
    return inpId;
  }
}

class IFChildElement extends NUIEnt<IFChildElement> with IFCommonJson implements NUIFSelection {
  IFChildElement.empty();
  NUIFTextItem otherText;

  @override
  NUIEntMapper<IFChildElement> mapper() => IFChildElementEnt();

  @override
  bool selected;

  @override
  String getCaption() => caption ?? inpId ?? "Title";

  @override
  Widget getCustomView() => null;

  @override
  TextStyle getFontStyle() => null;

  @override
  String getHint() => null;

  @override
  String getId() {
    if(inpId.isNullOrEmpty()){
      inpId = randomUUID();
    }
    return inpId;
  }

  @override
  String getValue() => caption ?? "Title";

  @override
  bool selectable() => true;

  @override
  NUIFTextItem getOtherTextItem() => otherText;
}

class IFChildElementEnt extends NUIEntMapper<IFChildElement>{
  @override
  String entityName() => "IFChildElement";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFChildElement>();
    return fields;
  }

  @override
  IFChildElement newInstance() => IFChildElement.empty();
}

