import 'package:iform/component/iform_common_json.dart';
import 'package:nui_core/data/nui_data_util.dart';
import 'package:nui_core/data/nui_ent.dart';

typedef IFDropDownOnValueChange = Function(String value);

class IFDropDownJson extends NUIEnt<IFDropDownJson> with IFCommonJson{
  IFDropDownJson.empty();
  int extraType1;
  List<String> optionInStrArr;
  IFDropDownOnValueChange onValueChange;
  Function onFocus;
  String otherTxtPlaceHolder;

  @override
  NUIEntMapper<IFDropDownJson> mapper() => IFDropDownJsonEnt();

  List<IFChildElement> getChildElements(){
    if(isNullOrEmpty(childElements)) return List();
    return childElements.map((e) => asObject<IFChildElement>(IFChildElementEnt(), e)).toList();
  }
}

class IFDropDownJsonEnt extends NUIEntMapper<IFDropDownJson>{
  @override
  String entityName() => "IFDropDownJson";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFDropDownJson>();
    fields.add(NUIEntField<IFDropDownJson>(name: "extraType1", type: NUIEntType.INTEGER, setter: (data, value) => data.extraType1 = value, getter: (data) => data.extraType1));
    fields.add(NUIEntField<IFDropDownJson>(name: "optionInStrArr", type: NUIEntType.LIST_STRING, setter: (data, value) => data.optionInStrArr = asList<String>(value), getter: (data) => data.optionInStrArr));
    fields.add(NUIEntField<IFDropDownJson>(name: "otherTxtPlaceHolder", type: NUIEntType.STRING, setter: (data, value) => data.otherTxtPlaceHolder = value, getter: (data) => data.otherTxtPlaceHolder));
    return fields;
  }

  @override
  IFDropDownJson newInstance() =>IFDropDownJson.empty();
}
