import 'package:nui_core/data/nui_ent.dart';
import 'iform_common_json.dart';

class IFLabelJson extends NUIEnt<IFLabelJson> with IFCommonJson{
  IFLabelJson.empty();
  int fontSize;
  int fontBoldItalic;
  String fontHexColor;
  int horizontalAlign;
  int verticalAlign;

  @override
  NUIEntMapper<IFLabelJson> mapper() => IFLabelJsonEnt();
}

class IFLabelJsonEnt extends NUIEntMapper<IFLabelJson>{
  @override
  String entityName() => "NUIFLabelJson";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFLabelJson>();
    fields.add(NUIEntField<IFLabelJson>(name: "fontSize", type: NUIEntType.INTEGER, setter: (data, value) => data.fontSize = value, getter: (data) => data.fontSize));
    fields.add(NUIEntField<IFLabelJson>(name: "fontBoldItalic", type: NUIEntType.INTEGER, setter: (data, value) => data.fontBoldItalic = value, getter: (data) => data.fontBoldItalic));
    fields.add(NUIEntField<IFLabelJson>(name: "fontHexColor", type: NUIEntType.STRING, setter: (data, value) => data.fontHexColor = value, getter: (data) => data.fontHexColor));
    fields.add(NUIEntField<IFLabelJson>(name: "horizontalAlign", type: NUIEntType.INTEGER, setter: (data, value) => data.horizontalAlign = value, getter: (data) => data.horizontalAlign));
    fields.add(NUIEntField<IFLabelJson>(name: "verticalAlign", type: NUIEntType.INTEGER, setter: (data, value) => data.verticalAlign = value, getter: (data) => data.verticalAlign));
    return fields;
  }

  @override
  IFLabelJson newInstance() => IFLabelJson.empty();
}