import 'package:iform/component/iform_common_json.dart';
import 'package:nui_core/nui_core.dart';

typedef IFSingleTextOnValueChange = Function(String value);

class IFSingleLineTextJson extends NUIEnt<IFSingleLineTextJson> with IFCommonJson{
  IFSingleLineTextJson.empty();
  IFSingleLineTextJson();
  String validateErrMsg;
  String butBesideImage; //Fontawesome
  String leftFontAwesome;
  String rightFontAwesome;
  int minCharStartInformTxtChanged;
  Function textDidChangeDueToEmptyAgainOrMinCharInput;
  Function onFocus;
  IFSingleTextOnValueChange onValueChange;
  String otherTxtPlaceHolder;
  int minLen;
  int maxLen;
  String minDate;
  String maxDate;
  int minValue;
  int maxValue;
  int inputAllowType;
  String inputAllowRegularExpression; //Reg exp
  String inputAllowTypeUserDefine;

  @override
  NUIEntMapper<IFSingleLineTextJson> mapper() => IFSingleLineTextJsonEnt();

  List<IFChildElement> getChildElements(){
    if(childElements.isNullOrEmpty()) return List();
    return childElements.map((e) => asObject<IFChildElement>(IFChildElementEnt(), e)).toList();
  }
}

class IFSingleLineTextJsonEnt extends NUIEntMapper<IFSingleLineTextJson>{
  @override
  String entityName() => "IFSingleLineTextJson";

  @override
  List<NUIEntField> fields() {
    final fields = IFCommonJson.dbFields<IFSingleLineTextJson>();
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "validateErrMsg", type: NUIEntType.STRING, setter: (data, value) => data.validateErrMsg = value, getter: (data) => data.validateErrMsg));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "butBesideImage", type: NUIEntType.STRING, setter: (data, value) => data.butBesideImage = value, getter: (data) => data.butBesideImage));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "leftFontAwesome", type: NUIEntType.STRING, setter: (data, value) => data.leftFontAwesome = value, getter: (data) => data.leftFontAwesome));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "rightFontAwesome", type: NUIEntType.STRING, setter: (data, value) => data.rightFontAwesome = value, getter: (data) => data.rightFontAwesome));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "minCharStartInformTxtChanged", type: NUIEntType.INTEGER, setter: (data, value) => data.minCharStartInformTxtChanged = value, getter: (data) => data.minCharStartInformTxtChanged));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "otherTxtPlaceHolder", type: NUIEntType.STRING, setter: (data, value) => data.otherTxtPlaceHolder = value, getter: (data) => data.otherTxtPlaceHolder));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "minLen", type: NUIEntType.INTEGER, setter: (data, value) => data.minLen = value, getter: (data) => data.minLen));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "maxLen", type: NUIEntType.INTEGER, setter: (data, value) => data.maxLen = value, getter: (data) => data.maxLen));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "minDate", type: NUIEntType.STRING, setter: (data, value) => data.minDate = value, getter: (data) => data.minDate));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "maxDate", type: NUIEntType.STRING, setter: (data, value) => data.maxDate = value, getter: (data) => data.maxDate));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "minValue", type: NUIEntType.INTEGER, setter: (data, value) => data.minValue = value, getter: (data) => data.minValue));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "maxValue", type: NUIEntType.INTEGER, setter: (data, value) => data.maxValue = value, getter: (data) => data.maxValue));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "inputAllowType", type: NUIEntType.INTEGER, setter: (data, value) => data.inputAllowType = value, getter: (data) => data.inputAllowType));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "inputAllowRegularExpression", type: NUIEntType.STRING, setter: (data, value) => data.inputAllowRegularExpression = value, getter: (data) => data.inputAllowRegularExpression));
    fields.add(NUIEntField<IFSingleLineTextJson>(name: "inputAllowTypeUserDefine", type: NUIEntType.STRING, setter: (data, value) => data.inputAllowTypeUserDefine = value, getter: (data) => data.inputAllowTypeUserDefine));
    return fields;
  }

  @override
  IFSingleLineTextJson newInstance() => IFSingleLineTextJson.empty();
}